
import hpjava.* ;


// Two remote processes connected by a new channel.

public class Eg9 {
  public static void main(String args[]) {

    // Create channel for communication with producer

    Port R = new Port() ;
    Port S = new Port() ;
    Port.channel(R, S) ;

    // Spawn producer

    RPC.spawn("Eg9Producer", "koum", R) ;

    // Create channel for communication with consumer

    Port T = new Port() ;
    Port U = new Port() ;
    Port.channel(T, U) ;

    // Spawn consumer

    RPC.spawn("Eg9Consumer", "naos", T) ;

    // Create channel for communication between producer and consumer

    Port P = new Port() ;
    Port Q = new Port() ;
    Port.channel(P, Q) ;

    // Send channel ends to spawned processes

    S.sendChan(P) ;
    U.sendChan(Q) ;
  }
}


